/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

/* load an empty text document */
oSheetComponent = xComponentLoader~loadComponentFromURL("private:factory/scalc", "_blank", 0, .OOo~noProps)

xDocument=oSheetComponent~XSpreadSheetDocument
xSheets=xDocument~getSheets
xIndexSheets=xSheets~XIndexAccess
xSheet=xIndexSheets~getByIndex(0)~XSpreadSheet  -- get the spreadsheet interface for the sheet

-- As a prerequisite, we populate the spreadsheet with some numeric values:
do i=0 to 4
	do j=0 to 3
		call OOo.setCell xSheet, i, j, i+j
	end
end

-- First create the elements the chart consists of:
-- (1) a frame (made from the Rectangle class)
oRect = .bsf~new("com.sun.star.awt.Rectangle")
oRect~x      = 500      -- note, since BSF4Rexx as of 2005-05-06, case of field names not case sensitive anymore!
oRect~y      = 3000
oRect~width  = 25000
oRect~height = 11000

-- (2) the underlying data (the numeric values come from a cell range)
myRange=xSheet~XCellRange ~getCellRangeByName("A1:E4")

-- Get the address of the underlying data (in our case a cell range)
myAddr=myRange~XCellRangeAddressable ~getRangeAddress

cellRangeAddressName = ooo.loadClass("com.sun.star.table.CellRangeAddress")
oAddr = bsf.createArray(cellRangeAddressName, 1)
oAddr[1] = myAddr

-- Now get the chart collection from the Sheet's charts supplier and add a new chart
-- Get the supplier and its charts
oCharts=xSheet~XTableChartsSupplier ~getCharts

-- Append a new chart to the collection
-- oCharts~addNewByName("Example", oRect, oAddr, "true", "true")
oCharts~addNewByName("Example", oRect, oAddr, .true, .true)

-- change diagram properties: 2-D to 3-D
oChart=oCharts~XNameAccess ~getByName("Example")
xChart=oChart~XTableChart
oEmb=xChart~XEmbeddedObjectSupplier ~getEmbeddedObject
oDiag=oEmb~XChartDocument ~getDiagram

-- change diagram to 3-D
oDiag~XPropertySet ~setPropertyValue("Dim3D", box("bool", .true))

::requires OOO.CLS   -- ooRexx support for OpenOffice.org
